"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _util = require("./util");

var _RouteLayout = _interopRequireDefault(require("./RouteLayout"));

// 'global' cache of resolved components to skip async fetching on repeat renders
var _componentCache = {}; // simple pass through component to use while real component is loading

var Placeholder = function Placeholder(_ref) {
  var React$Node = _ref.children;
  return _react.default.createElement("div", null);
};

var keyFromRoute = function keyFromRoute(route) {
  return (route.getComponent || '').toString();
};

var componentFromRoute = function componentFromRoute(route) {
  return route.component || // statically defined component
  _componentCache[keyFromRoute(route)] || // cached getComponent
  Placeholder;
}; // fallback placeholder while getComponent is resolved

/**
 * Route rendering component that uses internal state to keep a reference to the
 * wrapping component. If the `route` prop has a statically defined `component`,
 * it will be used on first render, otherwise it will be resolved using the
 * component 'getter' and the the result will be rendered (and cached).
 */


var AsyncRoute =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(AsyncRoute, _React$Component);

  function AsyncRoute() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, AsyncRoute);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(AsyncRoute)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "stopLoading", false);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      component: componentFromRoute(_this.props.route)
    });
    return _this;
  }

  (0, _createClass2.default)(AsyncRoute, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.resolveComponent();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.resolveComponent();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.stopLoading = true;
    }
  }, {
    key: "resolveComponent",
    value: function resolveComponent() {
      var _this2 = this;

      var route = this.props.route;

      if (this.state.component !== Placeholder || !route.getComponent) {
        // already resolved
        return;
      }

      var key = keyFromRoute(route);
      var cached = _componentCache[key];

      if (cached) {
        // something has been cached for this - no need to fetch
        if (this.state.component !== cached) {
          this.setState({
            component: cached
          });
        }

        return;
      }

      _componentCache[key] === Placeholder; // not cached yet - go get it

      route.getComponent().then(function (component) {
        // now cache it
        _componentCache[key] = component; // and set it to render if this route is still mounted and not already in sync

        if (_this2.stopLoading || _this2.state.component === component) {
          return;
        }

        _this2.setState({
          component: component
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          match = _this$props.match,
          route = _this$props.route,
          props = (0, _objectWithoutProperties2.default)(_this$props, ["match", "route"]);
      var Component = this.state.component;
      var childRoutes = (0, _util.getMatchedChildRoutes)({
        match: match,
        route: route
      });
      var params = (0, _util.decodeParams)(match.params); // React Router encodes the URL params - send decoded values to component

      return _react.default.createElement(Component, (0, _extends2.default)({}, props, {
        route: route,
        match: (0, _objectSpread2.default)({}, match, {
          params: params
        })
      }), childRoutes.length > 0 && _react.default.createElement(_RouteLayout.default, {
        routes: childRoutes,
        matchedPath: match.path
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var component = componentFromRoute(props.route);

      if (state.component === component) {
        return null;
      }

      return {
        component: component
      };
    }
  }]);
  return AsyncRoute;
}(_react.default.Component);

var _default = AsyncRoute;
exports.default = _default;
//# sourceMappingURL=AsyncRoute.js.map