"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.handleStateChangeOnClient = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireDefault(require("react"));

var _reactSideEffect = _interopRequireDefault(require("react-side-effect"));

var _Redirect = _interopRequireDefault(require("react-router-dom/Redirect"));

var _Route = _interopRequireDefault(require("react-router-dom/Route"));

var _util = require("./util");

/*
 * A routing component that, when rendered, will redirect the application to
 * another internal route _or_ external URL. On the server, the redirect will
 * be handled with a 301/302 redirect HTTP response to the browser - 301 when
 * the `permanent` prop has been set, 302 otherwise. On the client,
 * `window.location.replace` will be used for external URLs, but React Router
 * will respect a `push: false` property to decide whether to push or replace
 * ``window.history` state.
 *
 * Strings, location objects, and URL objects are all supported in the `to`
 * prop, but location objects will _only_ be treated as internal routes, and URL
 * objects will _only_ be treated as external URLs.
 *
 * Example:
 *
 * ```
 * // internal route, string URL
 * <Router to='/foo/bar' />
 * // internal route, location object
 * <Router to={{pathname: '/foo/bar', search: '?foo=bar', hash: '#thing'}} />
 *
 * // external URL, string URL
 * <Router to='http://example.com' />
 * // external URL, URL object
 * <Router to={new URL('http://example.com')} />

 * // internal route, permanent redirect
 * <Router to='/foo/bar' permanent />
 * // external URL, permanent redirect
 * <Router to='http://example.com' permanent />
 * ```
 */
var Redirect =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Redirect, _React$Component);

  function Redirect() {
    (0, _classCallCheck2.default)(this, Redirect);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Redirect).apply(this, arguments));
  }

  (0, _createClass2.default)(Redirect, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          to = _this$props.to,
          push = _this$props.push,
          permanent = _this$props.permanent;

      if (to instanceof URL || (0, _util.testForExternal)(to)) {
        // this is an external URL, so let `withSideEffect` handlers do redirect
        return null;
      } // internal route URL - <Route> provides access to the static routing
      // context on the server so we can populate the `permanent` value, and the
      // `<Redirect>` will populate the context `url` value or trigger the
      // `window.location` redirect in the browser


      return _react.default.createElement(_Route.default, {
        render: function render(_ref) {
          var staticContext = _ref.staticContext;

          if (staticContext) {
            // populate static context for server-side redirect
            staticContext.permanent = permanent;
          }

          return _react.default.createElement(_Redirect.default, {
            to: to,
            push: push
          });
        }
      });
    }
  }]);
  return Redirect;
}(_react.default.Component);

var reducePropsToState = function reducePropsToState(propsList) {
  if (propsList.length === 0) {
    // all Redirect instances have unmounted
    return;
  }

  var _propsList$pop = propsList.pop(),
      to = _propsList$pop.to,
      permanent = _propsList$pop.permanent;

  if (to instanceof URL) {
    // return the external URL as a string
    return {
      url: to.toString(),
      permanent: permanent
    };
  }

  if (!(0, _util.testForExternal)(to) || typeof to !== 'string') {
    // no external URL string
    return undefined;
  }

  return {
    url: to,
    permanent: permanent
  };
};

var handleStateChangeOnClient = function handleStateChangeOnClient(redirect) {
  if (!redirect || !(0, _util.testForExternal)(redirect.url)) {
    // 'internal' links will be handled by React Router
    return;
  }

  window.location.replace(redirect.url);
};

exports.handleStateChangeOnClient = handleStateChangeOnClient;

var _default = (0, _reactSideEffect.default)(reducePropsToState, handleStateChangeOnClient)(Redirect);

exports.default = _default;
//# sourceMappingURL=Redirect.js.map