"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _Switch = _interopRequireDefault(require("react-router-dom/Switch"));

var _Route = _interopRequireDefault(require("react-router-dom/Route"));

var _AsyncRoute = _interopRequireDefault(require("./AsyncRoute"));

var RouteLayout = function RouteLayout(props) {
  var routes = props.routes,
      _props$matchedPath = props.matchedPath,
      matchedPath = _props$matchedPath === void 0 ? '/' : _props$matchedPath;
  return _react.default.createElement(_Switch.default, null, routes.map(function (route) {
    var path = matchedPath === '/' // root path, no need to prepend
    ? route.path : "".concat(matchedPath).concat(route.path || '');
    return _react.default.createElement(_Route.default, {
      key: "".concat(path || 'empty', "-").concat(route.exact ? 'exact' : 'false'),
      path: path,
      exact: route.exact || false,
      strict: route.strict || false,
      render: function render(props) {
        return _react.default.createElement(_AsyncRoute.default, (0, _extends2.default)({}, props, {
          route: route
        }));
      }
    });
  }));
};

RouteLayout.propTypes = {
  routes: _propTypes.default.arrayOf(_propTypes.default.object).isRequired,
  matchedPath: _propTypes.default.string
};
var _default = RouteLayout;
exports.default = _default;
//# sourceMappingURL=RouteLayout.js.map