"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SyncContainer = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _withRouter = _interopRequireDefault(require("react-router-dom/withRouter"));

var _redux = require("redux");

var _reactRedux = require("react-redux");

var _routeActionCreators = require("./routeActionCreators");

function mapDispatchToProps(dispatch) {
  return {
    dispatchLocationChange: (0, _redux.bindActionCreators)(_routeActionCreators.locationChange, dispatch)
  };
}
/**
 * @module SyncContainer
 */


var SyncContainer =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(SyncContainer, _React$Component);

  function SyncContainer() {
    (0, _classCallCheck2.default)(this, SyncContainer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(SyncContainer).apply(this, arguments));
  }

  (0, _createClass2.default)(SyncContainer, [{
    key: "componentWillReceiveProps",

    /**
     * This container connects route changes to Redux actions. When the router
     * inject new props, the container determines whether or not to dispatch a
     * 'locationChange' action
     *
     * In order to prevent data fetches when the hash changes, we only compare
     * the new pathname and querystring with the current pathname and querystring
     *
     * @return {undefined} side effect only - dispatch
     */
    value: function componentWillReceiveProps(_ref) {
      var location = _ref.location,
          history = _ref.history;
      var isPathChange = location.pathname !== this.props.location.pathname;
      var isSearchChange = location.search !== this.props.location.search;

      if (isPathChange || isSearchChange) {
        this.props.dispatchLocationChange(location);

        if (history.action === 'PUSH' && isPathChange) {
          // new page - scroll to top
          window.scrollTo(0, 0);
        } // eventually we might want to try setting up some scroll logic for 'POP'
        // events (back button) to re-set the previous scroll position

      }
    }
    /**
     * @return {Function} React element
     */

  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);
  return SyncContainer;
}(_react.default.Component);

exports.SyncContainer = SyncContainer;
SyncContainer.propTypes = {
  children: _propTypes.default.element.isRequired,
  dispatchLocationChange: _propTypes.default.func.isRequired,
  location: _propTypes.default.object.isRequired,
  history: _propTypes.default.object.isRequired
};

var _default = (0, _reactRedux.connect)(null, mapDispatchToProps)((0, _withRouter.default)(SyncContainer));

exports.default = _default;
//# sourceMappingURL=SyncContainer.js.map