"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resolveAllRoutes = exports.resolveRoute = exports.addComponentToRoute = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

/**
 * Utilities for interacting with the Router and getting location data
 * @module routeUtils
 */
var addComponentToRoute = function addComponentToRoute(route) {
  return function (component) {
    if (!route.getComponent) {
      return Object.freeze((0, _objectSpread2.default)({
        component: component
      }, route));
    } // eslint-disable-next-line no-unused-vars


    var getComponent = route.getComponent,
        noGetCompRoute = (0, _objectWithoutProperties2.default)(route, ["getComponent"]);
    return Object.freeze((0, _objectSpread2.default)({
      component: component
    }, noGetCompRoute));
  };
}; // resolve the `component` property


exports.addComponentToRoute = addComponentToRoute;

var resolveComponent = function resolveComponent(route) {
  if (route.getComponent) {
    return route.getComponent();
  }

  return Promise.resolve(route.component);
};
/*
 * Resolve the current route and all children
 *
 * *Note* DO NOT USE THIS IN THE BROWSER - it will eagerly resolve all async
 * components
 */


var resolveRoute = function resolveRoute(route) {
  return Promise.all([resolveComponent(route), // $FlowFixMe - Flow doesn't realize the returned promise will be unwrapped
  resolveAllRoutes(route.routes || []), route.indexRoute ? resolveRoute(route.indexRoute) : Promise.resolve(null)]).then(function (_ref) {
    var _ref2 = (0, _slicedToArray2.default)(_ref, 3),
        component = _ref2[0],
        routes = _ref2[1],
        indexRoute = _ref2[2];

    if (indexRoute) {
      return Object.freeze((0, _objectSpread2.default)({}, addComponentToRoute(route)(component), {
        indexRoute: indexRoute,
        routes: routes
      }));
    }

    return Object.freeze((0, _objectSpread2.default)({}, addComponentToRoute(route)(component), {
      routes: routes
    }));
  });
};

exports.resolveRoute = resolveRoute;

var resolveAllRoutes = function resolveAllRoutes(routes) {
  return Promise.all(routes.map(resolveRoute));
};

exports.resolveAllRoutes = resolveAllRoutes;
//# sourceMappingURL=resolve.js.map