"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _resolve = require("./resolve");

var Component = function Component() {
  return _react.default.createElement("div", null);
};

var bar = {
  path: '/bar',
  getComponent: function getComponent() {
    return Promise.resolve(Component);
  }
};
var barResolved = {
  path: '/bar',
  component: Component,
  routes: []
};
var foo = {
  path: '/foo',
  getComponent: function getComponent() {
    return Promise.resolve(Component);
  },
  routes: [bar]
};
var fooResolved = {
  path: '/foo',
  component: Component,
  routes: [barResolved]
};
var qux = {
  path: '/qux',
  getComponent: function getComponent() {
    return Promise.resolve(Component);
  }
};
var quxResolved = {
  path: '/qux',
  component: Component,
  routes: []
};
var baz = {
  path: '/baz',
  component: Component,
  routes: [qux]
};
var bazResolved = {
  path: '/baz',
  component: Component,
  routes: [quxResolved]
};
var root = {
  path: '/',
  getComponent: function getComponent() {
    return Promise.resolve(Component);
  },
  indexRoute: qux,
  routes: [foo, baz]
};
var rootResolved = {
  path: '/',
  component: Component,
  indexRoute: quxResolved,
  routes: [fooResolved, bazResolved]
};
describe('addComponentToRoute', function () {
  it('adds a component to the route', function () {
    return expect((0, _resolve.addComponentToRoute)(qux)(Component)).toEqual({
      path: '/qux',
      component: Component
    });
  });
});
describe('resolveRoute', function () {
  it('resolves a single route', function () {
    return Promise.all([foo].map(_resolve.resolveRoute)).then(function (resolvedRoutes) {
      return expect(resolvedRoutes).toEqual([fooResolved]);
    });
  });
});
describe('resolveAllRoutes', function () {
  it('resolves all routes', function () {
    return (0, _resolve.resolveAllRoutes)([root]).then(function (resolvedRoutes) {
      expect(resolvedRoutes).toEqual([rootResolved]);
    });
  });
});
//# sourceMappingURL=resolve.test.js.map